/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production AddExpr : {@link AdditiveExpr};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:157
 */
public class AddExpr extends AdditiveExpr implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AddExpr clone() throws CloneNotSupportedException {
    AddExpr node = (AddExpr) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AddExpr copy() {
    try {
      AddExpr node = (AddExpr) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AddExpr fullCopy() {
    AddExpr tree = (AddExpr) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:172
   */

  public void typeCheck() {
    TypeDecl left = getLeftOperand().type();
    TypeDecl right = getRightOperand().type();
    if(!left.isString() && !right.isString())
      super.typeCheck();
    else if(left.isVoid())
      error("The type void of the left hand side is not numeric");
    else if(right.isVoid())
      error("The type void of the right hand side is not numeric");
  }
  /**
   * 
   * @ast method
   * @aspect CodeGenerationBinaryOperations
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CodeGeneration.jrag:576
   */

  void emitOperation(CodeGeneration gen) { type().add(gen); }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:922
   */

  public void createBCode(CodeGeneration gen) {
    if(!type().isString())
      super.createBCode(gen);
    else if(isConstant()) {
      StringLiteral.push(gen, constant().stringValue());
    }
    else {
      TypeDecl stringBuffer = lookupType("java.lang", "StringBuffer");
      String classname = stringBuffer.constantPoolName();
      String desc;
      int index;
      TypeDecl argumentType;
      if(firstStringAddPart()) {
        stringBuffer.emitNew(gen); // new StringBuffer
        gen.emitDup();             // dup
        desc = "()V";
        index = gen.constantPool().addMethodref(classname, "<init>", desc);
        gen.emit(Bytecode.INVOKESPECIAL, -1).add2(index); // invokespecial StringBuffer()
        getLeftOperand().createBCode(gen); // left
        argumentType = getLeftOperand().type().stringPromotion();
        desc = "(" + argumentType.typeDescriptor() + ")" + stringBuffer.typeDescriptor();
        index = gen.constantPool().addMethodref(classname, "append", desc);
        gen.emit(Bytecode.INVOKEVIRTUAL, -argumentType.variableSize()).add2(index); // StringBuffer.append
      }
      else {
        getLeftOperand().createBCode(gen);
      }
      getRightOperand().createBCode(gen); // right
      argumentType = getRightOperand().type().stringPromotion();
      desc = "(" + argumentType.typeDescriptor() + ")" + stringBuffer.typeDescriptor();
      index = gen.constantPool().addMethodref(classname, "append", desc);
      gen.emit(Bytecode.INVOKEVIRTUAL, -argumentType.variableSize()).add2(index); // StringBuffer.append
      if(lastStringAddPart()) {
        desc = "()" + type().typeDescriptor();
        index = gen.constantPool().addMethodref(classname, "toString", desc);
        gen.emit(Bytecode.INVOKEVIRTUAL, 0).add2(index); // StringBuffer.toString
      }
    }
  }
  /**
   * 
   * @ast method
   * 
   */

  public AddExpr() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public AddExpr(Expr p0, Expr p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        type_computed = false;
    type_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the LeftOperand child.
     * @param node The new node to replace the LeftOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setLeftOperand(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the LeftOperand child.
     * @return The current node used as the LeftOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getLeftOperand() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the LeftOperand child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the LeftOperand child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getLeftOperandNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the RightOperand child.
     * @param node The new node to replace the RightOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setRightOperand(Expr node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the RightOperand child.
     * @return The current node used as the RightOperand child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getRightOperand() {
    return (Expr) getChild(1);
  }
  /**
   * 
     * Retrieves the RightOperand child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the RightOperand child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getRightOperandNoTransform() {
    return (Expr) getChildNoTransform(1);
  }
    /**
     * @attribute syn
     * @aspect ConstantExpression
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/ConstantExpression.jrag:11
     */
  public Constant constant() {
    ASTNode$State state = state();
    try {  return type().add(getLeftOperand().constant(), getRightOperand().constant());  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PrettyPrint
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:400
     */
  public String printOp() {
    ASTNode$State state = state();
    try {  return " + ";  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean type_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl type_value;
  /**
   * @attribute syn
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:327
   */

  public TypeDecl type() {
    

    
if(type_computed) {
  return type_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    type_value = type_compute();
      if(isFinal && num == state().boundariesCrossed){ type_computed = true; }
        return type_value;
  }
  /**
   * @apilevel internal
   */
  private TypeDecl type_compute() {
      TypeDecl left = getLeftOperand().type();
      TypeDecl right = getRightOperand().type();
      if(!left.isString() && !right.isString())
        return super.type();
      else {
        if(left.isVoid() || right.isVoid())
          return unknownType();
        // pick the string type
        return left.isString() ? left : right;
      }
    }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:88
     */
  public boolean isStringAdd() {
    ASTNode$State state = state();
    try {  return type().isString() && !isConstant();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:91
     */
  public boolean firstStringAddPart() {
    ASTNode$State state = state();
    try {  return type().isString() && !getLeftOperand().isStringAdd();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect InnerClasses
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/InnerClasses.jrag:92
     */
  public boolean lastStringAddPart() {
    ASTNode$State state = state();
    try {  return !getParent().isStringAdd();  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
