/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production AssignExpr : {@link Expr} ::= <span class="component">Dest:{@link Expr}</span> <span class="component">Source:{@link Expr}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:105
 */
public abstract class AssignExpr extends Expr implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AssignExpr clone() throws CloneNotSupportedException {
    AssignExpr node = (AssignExpr) super.clone();
    return node;
  }
  /**
   * 
   * @ast method
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:463
   */

  protected boolean checkDUeverywhere(Variable v) {
    if(getDest().isVariable() && getDest().varDecl() == v)
      if(!getSource().isDAafter(v))
        return false;
    return super.checkDUeverywhere(v);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:295
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	getDest().prettyPrint(s);
	s.append(printOp());
	getSource().prettyPrint(s);
  }
  /**
   * 
   * @ast method
   * @aspect NodeConstructors
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NodeConstructors.jrag:94
   */

  public static Stmt asStmt(Expr left, Expr right) {
    return new ExprStmt(new AssignSimpleExpr(left, right));
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:241
   */

  public void toString(StringBuffer s) {
	getDest().toString(s);
	s.append(printOp());
	getSource().toString(s);
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:52
   */

  public void typeCheck() {
    if(!getDest().isVariable())
      error("left hand side is not a variable");
    else {
      TypeDecl source = sourceType();
      TypeDecl dest = getDest().type();
      if(getSource().type().isPrimitive() && getDest().type().isPrimitive())
        return;
      error("can not assign " + getDest() + " of type " + getDest().type().typeName() +
            " a value of type " + sourceType().typeName());
    }
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:352
   */

  public void emitShiftExpr(CodeGeneration gen) {
    TypeDecl dest = getDest().type();
    TypeDecl source = getSource().type();
    TypeDecl type = dest.unaryNumericPromotion();
    getDest().createAssignLoadDest(gen);
    dest.emitCastTo(gen, type);
    getSource().createBCode(gen);
    source.emitCastTo(gen, typeInt());
    createAssignOp(gen, type);
    type.emitCastTo(gen, dest);
    if(needsPush()) {
      getDest().createPushAssignmentResult(gen);
    }
    getDest().emitStore(gen);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:441
   */

  public void createAssignOp(CodeGeneration gen, TypeDecl type) {
    throw new Error("Operation createAssignOp is not implemented for " + getClass().getName());
  }
  /**
   * 
   * @ast method
   * 
   */

  public AssignExpr() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public AssignExpr(Expr p0, Expr p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        type_computed = false;
    type_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Dest child.
     * @param node The new node to replace the Dest child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setDest(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Dest child.
     * @return The current node used as the Dest child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getDest() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Dest child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Dest child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getDestNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Source child.
     * @param node The new node to replace the Source child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setSource(Expr node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Source child.
     * @return The current node used as the Source child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getSource() {
    return (Expr) getChild(1);
  }
  /**
   * 
     * Retrieves the Source child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Source child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getSourceNoTransform() {
    return (Expr) getChildNoTransform(1);
  }
  /**
   * 
   * @ast method
   * @aspect AutoBoxingCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/AutoBoxingCodegen.jrag:307
   */

    public void createBCode(CodeGeneration gen) {
    TypeDecl dest = getDest().type();
    TypeDecl source = getSource().type();
    TypeDecl type;
    if(dest.isNumericType() && source.isNumericType())
      type = dest.binaryNumericPromotion(source);
    else if(dest.isBoolean() && source.isBoolean()) {
      type = dest.isReferenceType() ? dest.unboxed() : dest;
    }
    else
      type = dest;
    getDest().createAssignLoadDest(gen);
    dest.emitCastTo(gen, type);
    getSource().createBCode(gen);
    source.emitCastTo(gen, type);
    createAssignOp(gen, type);
    type.emitCastTo(gen, dest);
    if(needsPush()) {
      getDest().createPushAssignmentResult(gen);
    }
    getDest().emitStore(gen);
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:235
     */
  public boolean isDAafter(Variable v) {
    ASTNode$State state = state();
    try {  return (getDest().isVariable() && getDest().varDecl() == v) || getSource().isDAafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:332
     */
  public boolean isDAafterTrue(Variable v) {
    ASTNode$State state = state();
    try {  return isDAafter(v) || isFalse();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:333
     */
  public boolean isDAafterFalse(Variable v) {
    ASTNode$State state = state();
    try {  return isDAafter(v) || isTrue();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:694
     */
  public boolean isDUafter(Variable v) {
    ASTNode$State state = state();
    try {  return getSource().isDUafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:702
     */
  public boolean isDUafterTrue(Variable v) {
    ASTNode$State state = state();
    try {  return isDUafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:703
     */
  public boolean isDUafterFalse(Variable v) {
    ASTNode$State state = state();
    try {  return isDUafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PrettyPrint
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:247
     */
  public String printOp() {
    ASTNode$State state = state();
    try {  return " = ";  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean type_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl type_value;
  /**
   * @attribute syn
   * @aspect TypeAnalysis
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeAnalysis.jrag:298
   */

  public TypeDecl type() {
    

    
if(type_computed) {
  return type_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    type_value = type_compute();
      if(isFinal && num == state().boundariesCrossed){ type_computed = true; }
        return type_value;
  }
  /**
   * @apilevel internal
   */
  private TypeDecl type_compute() {  return getDest().type();  }
    /**
     * @attribute syn
     * @aspect TypeCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:109
     */
  public TypeDecl sourceType() {
    ASTNode$State state = state();
    try {  return getSource().type().isPrimitive() ? getSource().type() : unknownType();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:241
     */
  public boolean needsPop() {
    ASTNode$State state = state();
    try {  return getDest().isVarAccessWithAccessor();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:111
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getDest().isVariable(var);  }
    finally {
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:19
   * @apilevel internal
   */
  public boolean Define_boolean_isDest(ASTNode caller, ASTNode child) {
    if(caller == getSourceNoTransform()) {
      return false;
    }
    else if(caller == getDestNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_isDest(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:29
   * @apilevel internal
   */
  public boolean Define_boolean_isSource(ASTNode caller, ASTNode child) {
    if(caller == getSourceNoTransform()) {
      return true;
    }
    else if(caller == getDestNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_isSource(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:392
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getDestNoTransform()) {
      return isDAbefore(v);
    }
    else if(caller == getSourceNoTransform()) {
      return getDest().isDAafter(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:828
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getDestNoTransform()) {
      return isDUbefore(v);
    }
    else if(caller == getSourceNoTransform()) {
      return getDest().isDUafter(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/SyntacticClassification.jrag:99
   * @apilevel internal
   */
  public NameType Define_NameType_nameType(ASTNode caller, ASTNode child) {
    if(caller == getDestNoTransform()) {
      return NameType.EXPRESSION_NAME;
    }
    else {      return getParent().Define_NameType_nameType(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
