/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production AssignPlusExpr : {@link AssignAdditiveExpr};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:115
 */
public class AssignPlusExpr extends AssignAdditiveExpr implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AssignPlusExpr clone() throws CloneNotSupportedException {
    AssignPlusExpr node = (AssignPlusExpr) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AssignPlusExpr copy() {
    try {
      AssignPlusExpr node = (AssignPlusExpr) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public AssignPlusExpr fullCopy() {
    AssignPlusExpr tree = (AssignPlusExpr) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:71
   */

  public void typeCheck() {
    if(!getDest().isVariable())
      error("left hand side is not a variable");
    else if(getSource().type().isUnknown() || getDest().type().isUnknown())
      return;
    else if(getDest().type().isString() && !(getSource().type().isVoid()))
      return;
    else if(getSource().type().isBoolean() || getDest().type().isBoolean())
      error("Operator + does not operate on boolean types");
    else if(getSource().type().isPrimitive() && getDest().type().isPrimitive())
      return;
    else
      error("can not assign " + getDest() + " of type " + getDest().type().typeName() +
            " a value of type " + sourceType().typeName());
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:302
   */

  public void createBCode(CodeGeneration gen) {
    TypeDecl dest = getDest().type();
    TypeDecl source = getSource().type();
    if(dest.isString()) {
      getDest().createAssignLoadDest(gen);

      // new StringBuffer()
      TypeDecl stringBuffer = lookupType("java.lang", "StringBuffer");
      String classname = stringBuffer.constantPoolName();
      String desc;
      int index;
      TypeDecl argumentType;
      stringBuffer.emitNew(gen); // new StringBuffer
      gen.emitDup();             // dup
      desc = "()V";
      index = gen.constantPool().addMethodref(classname, "<init>", desc);
      gen.emit(Bytecode.INVOKESPECIAL, -1).add2(index); // invokespecial StringBuffer()

      gen.emitSwap();

      // append
      argumentType = dest.stringPromotion();
      desc = "(" + argumentType.typeDescriptor() + ")" + stringBuffer.typeDescriptor();
      index = gen.constantPool().addMethodref(classname, "append", desc);
      gen.emit(Bytecode.INVOKEVIRTUAL, -argumentType.variableSize()).add2(index); // StringBuffer.append

      getSource().createBCode(gen);

      // typed append
      argumentType = source.stringPromotion();
      desc = "(" + argumentType.typeDescriptor() + ")" + stringBuffer.typeDescriptor();
      index = gen.constantPool().addMethodref(classname, "append", desc);
      gen.emit(Bytecode.INVOKEVIRTUAL, -argumentType.variableSize()).add2(index); // StringBuffer.append

      // toString
      desc = "()" + type().typeDescriptor();
      index = gen.constantPool().addMethodref(classname, "toString", desc);
      gen.emit(Bytecode.INVOKEVIRTUAL, 0).add2(index); // StringBuffer.toString

      if(needsPush()) {
        getDest().createPushAssignmentResult(gen);
      }
      getDest().emitStore(gen);
    }
    else {
      super.createBCode(gen);
    }
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:447
   */

  public void createAssignOp(CodeGeneration gen, TypeDecl type)    { type.add(gen); }
  /**
   * 
   * @ast method
   * 
   */

  public AssignPlusExpr() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public AssignPlusExpr(Expr p0, Expr p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
      }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Dest child.
     * @param node The new node to replace the Dest child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setDest(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Dest child.
     * @return The current node used as the Dest child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getDest() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Dest child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Dest child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getDestNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Source child.
     * @param node The new node to replace the Source child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setSource(Expr node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Source child.
     * @return The current node used as the Source child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getSource() {
    return (Expr) getChild(1);
  }
  /**
   * 
     * Retrieves the Source child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Source child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getSourceNoTransform() {
    return (Expr) getChildNoTransform(1);
  }
    /**
     * @attribute syn
     * @aspect PrettyPrint
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:247
     */
  public String printOp() {
    ASTNode$State state = state();
    try {  return " += ";  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect TypeCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:109
     */
  public TypeDecl sourceType() {
    ASTNode$State state = state();
    try {
        TypeDecl left = getDest().type();
        TypeDecl right = getSource().type();
        if(!left.isString() && !right.isString())
          return super.sourceType();
        if(left.isVoid() || right.isVoid())
          return unknownType();
        return left.isString() ? left : right;
      }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
