/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production ContinueStmt : {@link Stmt} ::= <span class="component">&lt;Label:String&gt;</span> <span class="component">[Finally:{@link Block}]</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:211
 */
public class ContinueStmt extends Stmt implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ContinueStmt clone() throws CloneNotSupportedException {
    ContinueStmt node = (ContinueStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ContinueStmt copy() {
    try {
      ContinueStmt node = (ContinueStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public ContinueStmt fullCopy() {
    ContinueStmt tree = (ContinueStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        switch (i) {
        case 0:
          tree.children[i] = new Opt();
          continue;
        }
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:75
   */

  public void collectBranches(Collection<Stmt> c) {
    c.add(this);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:769
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("continue ");
	if(hasLabel())
	  s.append(getLabel());
	s.append(";");
  }
  /**
   * 
   * @ast method
   * @aspect NameCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:411
   */

  public void nameCheck() {
    if(!insideLoop())
      error("continue outside loop");
    else if(hasLabel()) {
      LabeledStmt label = lookupLabel(getLabel());
      if(label == null)
        error("labeled continue must have visible matching label");
      else if(!label.getStmt().continueLabel())
        error(getLabel() + " is not a loop label");
    }
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:675
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("continue ");
	if(hasLabel())
	  s.append(getLabel());
	s.append(";");
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1481
   */

  public void createBCode(CodeGeneration gen) {
    super.createBCode(gen);
    if (hasFinally()) {
      int nextRange = hostType().constantPool().newLabel();
      getFinally().createBCode(gen);
      gen.emitGoto(targetStmt().continue_label());
      gen.addLabel(nextRange);
      gen.monitorRangesStart(this, nextRange);
    } else {
      gen.emitGoto(targetStmt().continue_label());
    }
  }
  /**
   * 
   * @ast method
   * 
   */

  public ContinueStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[1];
    setChild(new Opt(), 0);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ContinueStmt(String p0) {
    setLabel(p0);
  }
  /**
   * 
   * @ast method
   * 
   */

  public ContinueStmt(beaver.Symbol p0) {
    setLabel(p0);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 0;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        targetStmt_computed = false;
    targetStmt_value = null;
    isDAafter_Variable_values = null;
    isDUafterReachedFinallyBlocks_Variable_values = null;
    isDAafterReachedFinallyBlocks_Variable_values = null;
    isDUafter_Variable_values = null;
    getFinallyOpt_computed = false;
    getFinallyOpt_value = null;
    canCompleteNormally_computed = false;
    lookupLabel_String_values = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the lexeme Label.
     * @param value The new value for the lexeme Label.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setLabel(String value) {
    tokenString_Label = value;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  

  /**
   * @apilevel internal
   */
  protected String tokenString_Label;
  /**
   * 
   * @ast method
   * 
   */

  

  public int Labelstart;
  /**
   * 
   * @ast method
   * 
   */

  
  public int Labelend;
  /**
   * 
     * JastAdd-internal setter for lexeme Label using the Beaver parser.
     * @param symbol Symbol containing the new value for the lexeme Label
     * @apilevel internal
     
   * @ast method
   * 
   */

  public void setLabel(beaver.Symbol symbol) {
    if(symbol.value != null && !(symbol.value instanceof String))
    throw new UnsupportedOperationException("setLabel is only valid for String lexemes");
    tokenString_Label = (String)symbol.value;
    Labelstart = symbol.getStart();
    Labelend = symbol.getEnd();
  }
  /**
   * 
     * Retrieves the value for the lexeme Label.
     * @return The value for the lexeme Label.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public String getLabel() {
    return tokenString_Label != null ? tokenString_Label : "";
  }
  /**
   * 
     * Replaces the optional node for the Finally child. This is the {@code Opt}
     * node containing the child Finally, not the actual child!
     * @param opt The new node to be used as the optional node for the Finally child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setFinallyOpt(Opt<Block> opt) {
    setChild(opt, 0);
  }
  /**
   * 
     * Replaces the (optional) Finally child.
     * @param node The new node to be used as the Finally child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setFinally(Block node) {
    getFinallyOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional Finally child exists.
     * @return {@code true} if the optional Finally child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasFinally() {
    return getFinallyOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) Finally child.
     * @return The Finally child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Block getFinally() {
    return (Block) getFinallyOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for child Finally. This is the {@code Opt} node containing the child Finally, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child Finally.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Block> getFinallyOptNoTransform() {
    return (Opt<Block>) getChildNoTransform(0);
  }
  /**
   * 
     * Retrieves the child position of the optional child Finally.
     * @return The the child position of the optional child Finally.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int getFinallyOptChildPosition() {
    return 0;
  }
    /**
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:95
     */
  public boolean hasLabel() {
    ASTNode$State state = state();
    try {  return !getLabel().equals("");  }
    finally {
    }
  }
    /**
       * @return <code>true</code> if this statement can branch to
       * the target statement.
       
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:166
     */
  public boolean canBranchTo(BranchTargetStmt target) {
    ASTNode$State state = state();
    try {  return !hasLabel();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:167
     */
  public boolean canBranchTo(LabeledStmt target) {
    ASTNode$State state = state();
    try {  return hasLabel() && target.getLabel().equals(getLabel());  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:168
     */
  public boolean canBranchTo(SwitchStmt target) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean targetStmt_computed = false;
  /**
   * @apilevel internal
   */
  protected Stmt targetStmt_value;
  /**
     * Find the target statement for break and continue. This can be a try
     * statement with a finally block that can not complete normally.
     
   * @attribute syn
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:190
   */

  public Stmt targetStmt() {
    

    
if(targetStmt_computed) {
  return targetStmt_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    targetStmt_value = targetStmt_compute();
      if(isFinal && num == state().boundariesCrossed){ targetStmt_computed = true; }
        return targetStmt_value;
  }
  /**
   * @apilevel internal
   */
  private Stmt targetStmt_compute() {  return branchTarget(this);  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:648
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {  return true;  }
  protected java.util.Map isDUafterReachedFinallyBlocks_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:942
   */

  public boolean isDUafterReachedFinallyBlocks(Variable v) {
    Object _parameters = v;
    if(isDUafterReachedFinallyBlocks_Variable_values == null) isDUafterReachedFinallyBlocks_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafterReachedFinallyBlocks_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafterReachedFinallyBlocks_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafterReachedFinallyBlocks_Variable_value = isDUafterReachedFinallyBlocks_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafterReachedFinallyBlocks_Variable_values.put(_parameters, Boolean.valueOf(isDUafterReachedFinallyBlocks_Variable_value)); }
        return isDUafterReachedFinallyBlocks_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafterReachedFinallyBlocks_compute(Variable v) {
      Iterator<FinallyHost> iter = finallyIterator();
      if (!isDUbefore(v) && !iter.hasNext())
        return false;
      while (iter.hasNext()) {
        FinallyHost f = iter.next();
        if (!f.isDUafterFinally(v))
          return false;
      }
      return true;
    }
  protected java.util.Map isDAafterReachedFinallyBlocks_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:979
   */

  public boolean isDAafterReachedFinallyBlocks(Variable v) {
    Object _parameters = v;
    if(isDAafterReachedFinallyBlocks_Variable_values == null) isDAafterReachedFinallyBlocks_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafterReachedFinallyBlocks_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafterReachedFinallyBlocks_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafterReachedFinallyBlocks_Variable_value = isDAafterReachedFinallyBlocks_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafterReachedFinallyBlocks_Variable_values.put(_parameters, Boolean.valueOf(isDAafterReachedFinallyBlocks_Variable_value)); }
        return isDAafterReachedFinallyBlocks_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafterReachedFinallyBlocks_compute(Variable v) {
      if(isDAbefore(v))
        return true;
      Iterator<FinallyHost> iter = finallyIterator();
      if (!iter.hasNext())
        return false;
      while (iter.hasNext()) {
        FinallyHost f = iter.next();
        if(!f.isDAafterFinally(v))
          return false;
      }
      return true;
    }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1186
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {  return true;  }
  /**
   * @apilevel internal
   */
  protected boolean getFinallyOpt_computed = false;
  /**
   * @apilevel internal
   */
  protected Opt getFinallyOpt_value;
  /**
   * @attribute syn nta
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NTAFinally.jrag:55
   */

  public Opt getFinallyOpt() {
    

if(getFinallyOpt_computed) {
  return (Opt) getChild(getFinallyOptChildPosition());
}
    
if(getFinallyOpt_computed) {
  return getFinallyOpt_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    getFinallyOpt_value = getFinallyOpt_compute();
    setFinallyOpt(getFinallyOpt_value);
      if(isFinal && num == state().boundariesCrossed){ getFinallyOpt_computed = true; }
    Opt node = (Opt) this.getChild(getFinallyOptChildPosition());
        return node;
  }
  /**
   * @apilevel internal
   */
  private Opt getFinallyOpt_compute() {
      return branchFinallyOpt();
    }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:106
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return false;  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return false;  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect BranchTarget
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:230
   */

  public LabeledStmt lookupLabel(String name) {
    Object _parameters = name;
    if(lookupLabel_String_values == null) lookupLabel_String_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(lookupLabel_String_values.containsKey(_parameters)) {
  return (LabeledStmt)lookupLabel_String_values.get(_parameters); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    LabeledStmt lookupLabel_String_value = getParent().Define_LabeledStmt_lookupLabel(this, null, name);
      if(isFinal && num == state().boundariesCrossed){ lookupLabel_String_values.put(_parameters, lookupLabel_String_value); }
        return lookupLabel_String_value;
  }
  protected java.util.Map lookupLabel_String_values;
  /**
   * @attribute inh
   * @aspect NameCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:388
   */

  public boolean insideLoop() {
    ASTNode$State state = state();
    boolean insideLoop_value = getParent().Define_boolean_insideLoop(this, null);
        return insideLoop_value;
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
