/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production EnhancedForStmt : {@link BranchTargetStmt} ::= <span class="component">{@link VariableDeclaration}</span> <span class="component">{@link Expr}</span> <span class="component">{@link Stmt}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java5/grammar/EnhancedFor.ast:1
 */
public class EnhancedForStmt extends BranchTargetStmt implements Cloneable, VariableScope {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public EnhancedForStmt clone() throws CloneNotSupportedException {
    EnhancedForStmt node = (EnhancedForStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public EnhancedForStmt copy() {
    try {
      EnhancedForStmt node = (EnhancedForStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public EnhancedForStmt fullCopy() {
    EnhancedForStmt tree = (EnhancedForStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:20
   */

  public void typeCheck() {
    if (!getExpr().type().isArrayDecl() && !getExpr().type().isIterable()) {
      error("type " + getExpr().type().name() +
            " of expression in foreach is neither array type nor java.lang.Iterable");
    }
    else if(getExpr().type().isArrayDecl() && !getExpr().type().componentType().assignConversionTo(getVariableDeclaration().type(), null))
      error("parameter of type " + getVariableDeclaration().type().typeName() + " can not be assigned an element of type " + getExpr().type().componentType().typeName());
    else if(getExpr().type().isIterable() && !getExpr().type().isUnknown()) {
      MethodDecl iterator = (MethodDecl)getExpr().type().memberMethods("iterator").iterator().next();
      MethodDecl next = (MethodDecl)iterator.type().memberMethods("next").iterator().next();
      TypeDecl componentType = next.type();
      if(!componentType.assignConversionTo(getVariableDeclaration().type(), null))
        error("parameter of type " + getVariableDeclaration().type().typeName() + " can not be assigned an element of type " + componentType.typeName());
    }
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:63
   */

  public void toString(StringBuffer s) {
    s.append(indent());
    s.append("for (");
    getVariableDeclaration().getModifiers().toString(s);
    getVariableDeclaration().getTypeAccess().toString(s);
    s.append(" " + getVariableDeclaration().name());
    s.append(" : ");
    getExpr().toString(s);
    s.append(") ");
    getStmt().toString(s);
  }
  /**
   * 
   * @ast method
   * @aspect JDimeEnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/JDimeEnhancedFor.jrag:16
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
          return;

    s.append(indent());
    s.append("for (");
    getVariableDeclaration().getModifiers().prettyPrint(s);
    getVariableDeclaration().getTypeAccess().prettyPrint(s);
    s.append(" " + getVariableDeclaration().name());
    s.append(" : ");
    getExpr().prettyPrint(s);
    s.append(") ");
    getStmt().prettyPrint(s);
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:24
   */

  public void createBCode(CodeGeneration gen) {
    if(getExpr().type().isArrayDecl()) {
      getExpr().createBCode(gen);
      gen.emitStoreReference(extraLocalIndex());
      IntegerLiteral.push(gen, 0);
      gen.emit(Bytecode.ISTORE).add(extraLocalIndex()+1);
      gen.addLabel(cond_label());
      gen.emit(Bytecode.ILOAD).add(extraLocalIndex()+1);
      gen.emitLoadReference(extraLocalIndex());
      gen.emit(Bytecode.ARRAYLENGTH);
      gen.emitCompare(Bytecode.IF_ICMPGE, end_label());
      gen.emitLoadReference(extraLocalIndex());
      gen.emit(Bytecode.ILOAD).add(extraLocalIndex()+1);
      gen.emit(getExpr().type().componentType().arrayLoad());
      getExpr().type().componentType().emitCastTo(gen, getVariableDeclaration().type());
      getVariableDeclaration().type().emitStoreLocal(gen, getVariableDeclaration().localNum());
      getStmt().createBCode(gen);
      gen.addLabel(update_label());
      gen.emit(Bytecode.IINC).add(extraLocalIndex()+1).add(1);
      gen.emitGoto(cond_label());
      gen.addLabel(end_label());
    }
    else {
      getExpr().createBCode(gen);
      iteratorMethod().emitInvokeMethod(gen, lookupType("java.lang", "Iterable"));
      gen.emitStoreReference(extraLocalIndex());
      gen.addLabel(cond_label());
      gen.emitLoadReference(extraLocalIndex());
      hasNextMethod().emitInvokeMethod(gen, lookupType("java.util", "Iterator"));
      gen.emitCompare(Bytecode.IFEQ, end_label());
      gen.emitLoadReference(extraLocalIndex());
      nextMethod().emitInvokeMethod(gen, lookupType("java.util", "Iterator"));
      VariableDeclaration obj = getVariableDeclaration();
      if (!obj.type().boxed().isUnknown()) {
        gen.emitCheckCast(obj.type().boxed());
        obj.type().boxed().emitCastTo(gen, obj.type());
        obj.type().emitStoreLocal(gen, obj.localNum());
      } else {
        gen.emitCheckCast(obj.type());
        gen.emitStoreReference(obj.localNum());
      }
      getStmt().createBCode(gen);
      gen.addLabel(update_label());
      gen.emitGoto(cond_label());
      gen.addLabel(end_label());
    }
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:72
   */

  private MethodDecl iteratorMethod() {
    TypeDecl typeDecl = lookupType("java.lang", "Iterable");
    for (Iterator iter = typeDecl.memberMethods("iterator").iterator(); iter.hasNext();) {
      MethodDecl m = (MethodDecl)iter.next();
      if (m.getNumParameter() == 0) {
        return m;
      }
    }
    throw new Error("Could not find java.lang.Iterable.iterator()");
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:82
   */

  private MethodDecl hasNextMethod() {
    TypeDecl typeDecl = lookupType("java.util", "Iterator");
    for (Iterator iter = typeDecl.memberMethods("hasNext").iterator(); iter.hasNext();) {
      MethodDecl m = (MethodDecl)iter.next();
      if (m.getNumParameter() == 0) {
        return m;
      }
    }
    throw new Error("Could not find java.util.Collection.hasNext()");
  }
  /**
   * 
   * @ast method
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:92
   */

  private MethodDecl nextMethod() {
    TypeDecl typeDecl = lookupType("java.util", "Iterator");
    for (Iterator iter = typeDecl.memberMethods("next").iterator(); iter.hasNext();) {
      MethodDecl m = (MethodDecl)iter.next();
      if (m.getNumParameter() == 0) {
        return m;
      }
    }
    throw new Error("Could not find java.util.Collection.next()");
  }
  /**
   * 
   * @ast method
   * 
   */

  public EnhancedForStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[3];
  }
  /**
   * 
   * @ast method
   * 
   */

  public EnhancedForStmt(VariableDeclaration p0, Expr p1, Stmt p2) {
    setChild(p0, 0);
    setChild(p1, 1);
    setChild(p2, 2);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 3;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        canCompleteNormally_computed = false;
    isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    cond_label_computed = false;
    update_label_computed = false;
    end_label_computed = false;
    extraLocalIndex_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the VariableDeclaration child.
     * @param node The new node to replace the VariableDeclaration child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setVariableDeclaration(VariableDeclaration node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the VariableDeclaration child.
     * @return The current node used as the VariableDeclaration child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public VariableDeclaration getVariableDeclaration() {
    return (VariableDeclaration) getChild(0);
  }
  /**
   * 
     * Retrieves the VariableDeclaration child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the VariableDeclaration child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public VariableDeclaration getVariableDeclarationNoTransform() {
    return (VariableDeclaration) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Expr child.
     * @param node The new node to replace the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExpr(Expr node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Expr child.
     * @return The current node used as the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getExpr() {
    return (Expr) getChild(1);
  }
  /**
   * 
     * Retrieves the Expr child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Expr child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getExprNoTransform() {
    return (Expr) getChildNoTransform(1);
  }
  /**
   * 
     * Replaces the Stmt child.
     * @param node The new node to replace the Stmt child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmt(Stmt node) {
    setChild(node, 2);
  }
  /**
   * 
     * Retrieves the Stmt child.
     * @return The current node used as the Stmt child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Stmt getStmt() {
    return (Stmt) getChild(2);
  }
  /**
   * 
     * Retrieves the Stmt child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Stmt child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Stmt getStmtNoTransform() {
    return (Stmt) getChildNoTransform(2);
  }
    /**
     * @attribute syn
     * @aspect EnhancedFor
     * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:55
     */
  public SimpleSet localLookupVariable(String name) {
    ASTNode$State state = state();
    try {
        if(getVariableDeclaration().name().equals(name)) {
          return SimpleSet.emptySet.add(getVariableDeclaration());
        }
        return lookupVariable(name);
      }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:81
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return reachable();  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:85
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {
      if(!getExpr().isDAafter(v))
        return false;
      /*
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDAafterReachedFinallyBlocks(v))
          return false;
      }
      */
      return true;
    }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:101
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {
      if(!getExpr().isDUafter(v))
        return false;
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDUafterReachedFinallyBlocks(v))
          return false;
      }
      return true;
    }
    /**
     * @attribute syn
     * @aspect NameCheck
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:423
     */
  public boolean continueLabel() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean cond_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int cond_label_value;
  /**
   * @attribute syn
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:12
   */

  public int cond_label() {
    

    
if(cond_label_computed) {
  return cond_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    cond_label_value = cond_label_compute();
      if(isFinal && num == state().boundariesCrossed){ cond_label_computed = true; }
        return cond_label_value;
  }
  /**
   * @apilevel internal
   */
  private int cond_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean update_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int update_label_value;
  /**
   * @attribute syn
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:13
   */

  public int update_label() {
    

    
if(update_label_computed) {
  return update_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    update_label_value = update_label_compute();
      if(isFinal && num == state().boundariesCrossed){ update_label_computed = true; }
        return update_label_value;
  }
  /**
   * @apilevel internal
   */
  private int update_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int end_label_value;
  /**
   * @attribute syn
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:14
   */

  public int end_label() {
    

    
if(end_label_computed) {
  return end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    end_label_value = end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ end_label_computed = true; }
        return end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int end_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean extraLocalIndex_computed = false;
  /**
   * @apilevel internal
   */
  protected int extraLocalIndex_value;
  /**
   * @attribute syn
   * @aspect EnhancedForToBytecode
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:16
   */

  public int extraLocalIndex() {
    

    
if(extraLocalIndex_computed) {
  return extraLocalIndex_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    extraLocalIndex_value = extraLocalIndex_compute();
      if(isFinal && num == state().boundariesCrossed){ extraLocalIndex_computed = true; }
        return extraLocalIndex_value;
  }
  /**
   * @apilevel internal
   */
  private int extraLocalIndex_compute() {  return localNum();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1446
     */
  public int break_label() {
    ASTNode$State state = state();
    try {  return end_label();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1470
     */
  public int continue_label() {
    ASTNode$State state = state();
    try {  return update_label();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getStmt().modifiedInScope(var);  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect EnhancedFor
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:43
   */

  public SimpleSet lookupVariable(String name) {
    ASTNode$State state = state();
    SimpleSet lookupVariable_String_value = getParent().Define_SimpleSet_lookupVariable(this, null, name);
        return lookupVariable_String_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:16
   * @apilevel internal
   */
  public Stmt Define_Stmt_branchTarget(ASTNode caller, ASTNode child, Stmt branch) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return branch.canBranchTo(this) ? this : branchTarget(branch);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:46
   * @apilevel internal
   */
  public SimpleSet Define_SimpleSet_lookupVariable(ASTNode caller, ASTNode child, String name) {
    if(caller == getStmtNoTransform()) {
      return localLookupVariable(name);
    }
    else if(caller == getExprNoTransform()) {
      return localLookupVariable(name);
    }
    else if(caller == getVariableDeclarationNoTransform()) {
      return localLookupVariable(name);
    }
    else {      return getParent().Define_SimpleSet_lookupVariable(this, caller, name);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:48
   * @apilevel internal
   */
  public NameType Define_NameType_nameType(ASTNode caller, ASTNode child) {
    if(caller == getVariableDeclarationNoTransform()) {
      return NameType.TYPE_NAME;
    }
    else {      return getParent().Define_NameType_nameType(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:53
   * @apilevel internal
   */
  public VariableScope Define_VariableScope_outerScope(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return this;
    }
    else if(caller == getExprNoTransform()) {
      return this;
    }
    else if(caller == getVariableDeclarationNoTransform()) {
      return this;
    }
    else {      return getParent().Define_VariableScope_outerScope(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:76
   * @apilevel internal
   */
  public boolean Define_boolean_isMethodParameter(ASTNode caller, ASTNode child) {
    if(caller == getVariableDeclarationNoTransform()) {
      return false;
    }
    else {      return getParent().Define_boolean_isMethodParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:77
   * @apilevel internal
   */
  public boolean Define_boolean_isConstructorParameter(ASTNode caller, ASTNode child) {
    if(caller == getVariableDeclarationNoTransform()) {
      return false;
    }
    else {      return getParent().Define_boolean_isConstructorParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:78
   * @apilevel internal
   */
  public boolean Define_boolean_isExceptionHandlerParameter(ASTNode caller, ASTNode child) {
    if(caller == getVariableDeclarationNoTransform()) {
      return false;
    }
    else {      return getParent().Define_boolean_isExceptionHandlerParameter(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:82
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:99
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getStmtNoTransform()) {
      return getExpr().isDAafter(v);
    }
    else if(caller == getExprNoTransform()) {
      return v == getVariableDeclaration() || isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:113
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getStmtNoTransform()) {
      return getExpr().isDUafter(v);
    }
    else if(caller == getExprNoTransform()) {
      return v != getVariableDeclaration() && isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/EnhancedFor.jrag:115
   * @apilevel internal
   */
  public boolean Define_boolean_insideLoop(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_insideLoop(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnhancedForCodegen.jrag:18
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
    if(caller == getStmtNoTransform()) {
      return getVariableDeclaration().localNum() + getVariableDeclaration().type().size();
    }
    else if(caller == getVariableDeclarationNoTransform()) {
      return localNum() + (getExpr().type().isArrayDecl() ? 2 : 1);
    }
    else {      return getParent().Define_int_localNum(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
