/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production IfStmt : {@link Stmt} ::= <span class="component">Condition:{@link Expr}</span> <span class="component">Then:{@link Stmt}</span> <span class="component">[Else:{@link Stmt}]</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:205
 */
public class IfStmt extends Stmt implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public IfStmt clone() throws CloneNotSupportedException {
    IfStmt node = (IfStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public IfStmt copy() {
    try {
      IfStmt node = (IfStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public IfStmt fullCopy() {
    IfStmt tree = (IfStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:653
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("if(");
	getCondition().prettyPrint(s);
	s.append(") ");
	getThen().prettyPrint(s);
	if(hasElse()) {
	  s.append(indent());
	  s.append("else ");
	  getElse().prettyPrint(s);
	}
  }
  /**
   * 
   * @ast method
   * @aspect NodeConstructors
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NodeConstructors.jrag:66
   */

  public IfStmt(Expr cond, Stmt thenBranch) {
    this(cond, thenBranch, new Opt());
  }
  /**
   * 
   * @ast method
   * @aspect NodeConstructors
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NodeConstructors.jrag:70
   */

  public IfStmt(Expr cond, Stmt thenBranch, Stmt elseBranch) {
    this(cond, thenBranch, new Opt(elseBranch));
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:574
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("if(");
	getCondition().toString(s);
	s.append(") ");
	getThen().toString(s);
	if(hasElse()) {
	  s.append(indent());
	  s.append("else ");
	  getElse().toString(s);
	}
  }
  /**
   * 
   * @ast method
   * @aspect TypeCheck
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:316
   */

  public void typeCheck() {
    TypeDecl cond = getCondition().type();
    if(!cond.isBoolean()) {
      error("the type of \"" + getCondition() + "\" is " + cond.name() + " which is not boolean");
    }
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1372
   */

  public void createBCode(CodeGeneration gen) {
    super.createBCode(gen);
    int elseBranch = else_branch_label();
    int thenBranch = then_branch_label();
    int endBranch = end_label();
    getCondition().emitEvalBranch(gen);
    gen.addLabel(thenBranch);
    //if(getCondition().canBeTrue()) {
      getThen().createBCode(gen);
      if(getThen().canCompleteNormally() && hasElse() /*&& getCondition().canBeFalse()*/)
        gen.emitGoto(endBranch);
    //}
    gen.addLabel(elseBranch);
    if(hasElse() /*&& getCondition().canBeFalse()*/)
      getElse().createBCode(gen);
    gen.addLabel(endBranch);
  }
  /**
   * 
   * @ast method
   * 
   */

  public IfStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[3];
    setChild(new Opt(), 2);
  }
  /**
   * 
   * @ast method
   * 
   */

  public IfStmt(Expr p0, Stmt p1, Opt<Stmt> p2) {
    setChild(p0, 0);
    setChild(p1, 1);
    setChild(p2, 2);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 3;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    canCompleteNormally_computed = false;
    else_branch_label_computed = false;
    then_branch_label_computed = false;
    end_label_computed = false;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Condition child.
     * @param node The new node to replace the Condition child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setCondition(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Condition child.
     * @return The current node used as the Condition child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getCondition() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Condition child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Condition child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getConditionNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Then child.
     * @param node The new node to replace the Then child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setThen(Stmt node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Then child.
     * @return The current node used as the Then child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Stmt getThen() {
    return (Stmt) getChild(1);
  }
  /**
   * 
     * Retrieves the Then child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Then child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Stmt getThenNoTransform() {
    return (Stmt) getChildNoTransform(1);
  }
  /**
   * 
     * Replaces the optional node for the Else child. This is the {@code Opt}
     * node containing the child Else, not the actual child!
     * @param opt The new node to be used as the optional node for the Else child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void setElseOpt(Opt<Stmt> opt) {
    setChild(opt, 2);
  }
  /**
   * 
     * Replaces the (optional) Else child.
     * @param node The new node to be used as the Else child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setElse(Stmt node) {
    getElseOpt().setChild(node, 0);
  }
  /**
   * 
     * Check whether the optional Else child exists.
     * @return {@code true} if the optional Else child exists, {@code false} if it does not.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public boolean hasElse() {
    return getElseOpt().getNumChild() != 0;
  }
  /**
   * 
     * Retrieves the (optional) Else child.
     * @return The Else child, if it exists. Returns {@code null} otherwise.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Stmt getElse() {
    return (Stmt) getElseOpt().getChild(0);
  }
  /**
   * 
     * Retrieves the optional node for the Else child. This is the {@code Opt} node containing the child Else, not the actual child!
     * @return The optional node for child the Else child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Stmt> getElseOpt() {
    return (Opt<Stmt>) getChild(2);
  }
  /**
   * 
     * Retrieves the optional node for child Else. This is the {@code Opt} node containing the child Else, not the actual child!
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The optional node for child Else.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Opt<Stmt> getElseOptNoTransform() {
    return (Opt<Stmt>) getChildNoTransform(2);
  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:525
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {  return hasElse() ? getThen().isDAafter(v) && getElse().isDAafter(v) : getThen().isDAafter(v) && getCondition().isDAafterFalse(v);  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1009
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {  return hasElse() ? getThen().isDUafter(v) && getElse().isDUafter(v) : getThen().isDUafter(v) && getCondition().isDUafterFalse(v);  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:141
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return (reachable() && !hasElse()) || (getThen().canCompleteNormally() ||
      (hasElse() && getElse().canCompleteNormally()));  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:968
     */
  public boolean definesLabel() {
    ASTNode$State state = state();
    try {  return true;  }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean else_branch_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int else_branch_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1369
   */

  public int else_branch_label() {
    

    
if(else_branch_label_computed) {
  return else_branch_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    else_branch_label_value = else_branch_label_compute();
      if(isFinal && num == state().boundariesCrossed){ else_branch_label_computed = true; }
        return else_branch_label_value;
  }
  /**
   * @apilevel internal
   */
  private int else_branch_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean then_branch_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int then_branch_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1370
   */

  public int then_branch_label() {
    

    
if(then_branch_label_computed) {
  return then_branch_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    then_branch_label_value = then_branch_label_compute();
      if(isFinal && num == state().boundariesCrossed){ then_branch_label_computed = true; }
        return then_branch_label_value;
  }
  /**
   * @apilevel internal
   */
  private int then_branch_label_compute() {  return hostType().constantPool().newLabel();  }
  /**
   * @apilevel internal
   */
  protected boolean end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int end_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1371
   */

  public int end_label() {
    

    
if(end_label_computed) {
  return end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    end_label_value = end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ end_label_computed = true; }
        return end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int end_label_compute() {  return hostType().constantPool().newLabel();  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {
        if (getThen().modifiedInScope(var))
          return true;
        return hasElse() && getElse().modifiedInScope(var);
      }
    finally {
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:528
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getElseOptNoTransform()) {
      return getCondition().isDAafterFalse(v);
    }
    else if(caller == getThenNoTransform()) {
      return getCondition().isDAafterTrue(v);
    }
    else if(caller == getConditionNoTransform()) {
      return isDAbefore(v);
    }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1012
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getElseOptNoTransform()) {
      return getCondition().isDUafterFalse(v);
    }
    else if(caller == getThenNoTransform()) {
      return getCondition().isDUafterTrue(v);
    }
    else if(caller == getConditionNoTransform()) {
      return isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:144
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getElseOptNoTransform()) {
      return reachable();
    }
    else if(caller == getThenNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:150
   * @apilevel internal
   */
  public boolean Define_boolean_reportUnreachable(ASTNode caller, ASTNode child) {
    if(caller == getElseOptNoTransform()) {
      return reachable();
    }
    else if(caller == getThenNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reportUnreachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:985
   * @apilevel internal
   */
  public int Define_int_condition_false_label(ASTNode caller, ASTNode child) {
    if(caller == getConditionNoTransform()) {
      return else_branch_label();
    }
    else {      return getParent().Define_int_condition_false_label(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:986
   * @apilevel internal
   */
  public int Define_int_condition_true_label(ASTNode caller, ASTNode child) {
    if(caller == getConditionNoTransform()) {
      return then_branch_label();
    }
    else {      return getParent().Define_int_condition_true_label(this, caller);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
