/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * This node only exists to distinguish NTA-finally blocks from
 * regular, non-NTA, blocks. This is required to avoid an endlessly
 * recursive AST.
 * @production NTAFinallyBlock : {@link Block};
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/NTAFinally.ast:6
 */
public class NTAFinallyBlock extends Block implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public NTAFinallyBlock clone() throws CloneNotSupportedException {
    NTAFinallyBlock node = (NTAFinallyBlock) super.clone();
    node.in$Circle(false);
    node.is$Final(false);
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public NTAFinallyBlock copy() {
    try {
      NTAFinallyBlock node = (NTAFinallyBlock) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public NTAFinallyBlock fullCopy() {
    NTAFinallyBlock tree = (NTAFinallyBlock) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NTAFinally.jrag:89
   */

  

  private FinallyHost origin;
  /**
   * 
   * @ast method
   * @aspect NTAFinally
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NTAFinally.jrag:91
   */

  public NTAFinallyBlock(FinallyHost finallyHost) {
    this.origin = finallyHost;
  }
  /**
   * 
   * @ast method
   * 
   */

  public NTAFinallyBlock() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[1];
    setChild(new List(), 0);
  }
  /**
   * 
   * @ast method
   * 
   */

  public NTAFinallyBlock(List<Stmt> p0) {
    setChild(p0, 0);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 1;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
      }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Stmt list.
     * @param list The new list node to be used as the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmtList(List<Stmt> list) {
    setChild(list, 0);
  }
  /**
   * 
     * Retrieves the number of children in the Stmt list.
     * @return Number of children in the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public int getNumStmt() {
    return getStmtList().getNumChild();
  }
  /**
   * 
     * Retrieves the number of children in the Stmt list.
     * Calling this method will not trigger rewrites.
     * @return Number of children in the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public int getNumStmtNoTransform() {
    return getStmtListNoTransform().getNumChildNoTransform();
  }
  /**
   * 
     * Retrieves the element at index {@code i} in the Stmt list.
     * @param i Index of the element to return.
     * @return The element at position {@code i} in the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public Stmt getStmt(int i) {
    return (Stmt) getStmtList().getChild(i);
  }
  /**
   * 
     * Append an element to the Stmt list.
     * @param node The element to append to the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void addStmt(Stmt node) {
    List<Stmt> list = (parent == null || state == null) ? getStmtListNoTransform() : getStmtList();
    list.addChild(node);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public void addStmtNoTransform(Stmt node) {
    List<Stmt> list = getStmtListNoTransform();
    list.addChild(node);
  }
  /**
   * 
     * Replaces the Stmt list element at index {@code i} with the new node {@code node}.
     * @param node The new node to replace the old list element.
     * @param i The list index of the node to be replaced.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setStmt(Stmt node, int i) {
    List<Stmt> list = getStmtList();
    list.setChild(node, i);
  }
  /**
   * 
     * Retrieves the Stmt list.
     * @return The node representing the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Stmt> getStmtList() {
    List<Stmt> list = (List<Stmt>) getChild(0);
    list.getNumChild();
    return list;
  }
  /**
   * 
     * Retrieves the Stmt list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  @SuppressWarnings({"unchecked", "cast"})
  public List<Stmt> getStmtListNoTransform() {
    return (List<Stmt>) getChildNoTransform(0);
  }
  /**
   * 
     * Retrieves the Stmt list.
     * @return The node representing the Stmt list.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public List<Stmt> getStmts() {
    return getStmtList();
  }
  /**
   * 
     * Retrieves the Stmt list.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The node representing the Stmt list.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public List<Stmt> getStmtsNoTransform() {
    return getStmtListNoTransform();
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:264
   * @apilevel internal
   */
  public FinallyHost Define_FinallyHost_enclosingFinally(ASTNode caller, ASTNode child, Stmt branch) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return origin.enclosingFinally(branch);
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
