/* This file was generated with JastAdd2 (http://jastadd.org) version R20130412-32-gf380c36 */
package AST;

import java.util.HashSet;
import java.io.File;
import java.util.*;
import beaver.*;
import org.jastadd.util.*;
import java.util.ArrayList;
import java.util.zip.*;
import java.io.*;
import java.io.FileNotFoundException;
import java.util.Collection;
/**
 * @production SwitchStmt : {@link BranchTargetStmt} ::= <span class="component">{@link Expr}</span> <span class="component">{@link Block}</span>;
 * @ast node
 * @declaredat /home/lessenic/workspace/jastaddj/java4/grammar/Java.ast:200
 */
public class SwitchStmt extends BranchTargetStmt implements Cloneable {
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SwitchStmt clone() throws CloneNotSupportedException {
    SwitchStmt node = (SwitchStmt) super.clone();
    return node;
  }
  /**
   * @apilevel internal
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SwitchStmt copy() {
    try {
      SwitchStmt node = (SwitchStmt) clone();
      node.parent = null;
      if(children != null) {
        node.children = (ASTNode[]) children.clone();
      }
      return node;
    } catch (CloneNotSupportedException e) {
      throw new Error("Error: clone not supported for " + getClass().getName());
    }
  }
  /**
   * Create a deep copy of the AST subtree at this node.
   * The copy is dangling, i.e. has no parent.
   * @return dangling copy of the subtree at this node
   * @apilevel low-level
   */
  @SuppressWarnings({"unchecked", "cast"})
  public SwitchStmt fullCopy() {
    SwitchStmt tree = (SwitchStmt) copy();
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        ASTNode child = (ASTNode) children[i];
        if(child != null) {
          child = child.fullCopy();
          tree.setChild(child, i);
        }
      }
    }
    return tree;
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/JDimePrettyPrint.jadd:624
   */

  public void prettyPrint(StringBuffer s) {
      if (printConflict(s))
	  return;
      
	s.append(indent());
	s.append("switch (");
	getExpr().prettyPrint(s);
	s.append(")");
	getBlock().prettyPrint(s);
  }
  /**
   * 
   * @ast method
   * @aspect PrettyPrint
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/PrettyPrint.jadd:554
   */

  public void toString(StringBuffer s) {
	s.append(indent());
	s.append("switch (");
	getExpr().toString(s);
	s.append(")");
	getBlock().toString(s);
  }
  /**
   * 
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1337
   */

  private int emitPad(CodeGeneration gen) {
    int pad = (4 - (gen.pos() % 4)) % 4;
    for (int i = 0; i < pad; i++) {
      gen.emit(Bytecode.NOP);
    }
    if (gen.pos() % 4 != 0) {
      throw new Error("Switch not at 4-byte boundary:" + gen.pos());
    }
    return pad;
  }
  /**
   * 
     * Calculate offset to the default label.
     * @return bytecode offset to default label (or zero if there is no
     * default label)
     
   * @ast method
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1353
   */

  private int defaultOffset(CodeGeneration gen, int switch_label) {
    DefaultCase defaultCase = defaultCase();
    if (defaultCase != null) {
      int offset = gen.addressOf(defaultCase.label())
        - gen.addressOf(switch_label);
      return offset;
    }
    return 0;
  }
  /**
   * 
   * @ast method
   * @aspect EnumsCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/EnumsCodegen.jrag:17
   */

  public void transformation() {
    if(getExpr().type().isEnumDecl()) {
      TypeDecl type = getExpr().type();
      hostType().createEnumArray(type);
      hostType().createEnumMethod(type);
      setExpr(
        hostType().createEnumMethod(type).createBoundAccess(new List()).qualifiesAccess(
        new ArrayAccess(
          ((Expr)getExpr().fullCopy()).qualifiesAccess(new MethodAccess("ordinal", new List()))
        ))
      );
    }
    super.transformation();
  }
  /**
   * 
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:156
   */

  private void genFirstSwitch(
      CodeGeneration gen,
      TreeMap<Integer, CaseGroup> groups,
      int index_a) {
    int switch_label = hostType().constantPool().newLabel();
    int end_label1 = hostType().constantPool().newLabel();
    int index_b = localNumB();

    // Initialize switch variable for second switch
    IntegerLiteral.push(gen, 0);
    typeInt().emitStoreLocal(gen, index_a);

    // Store the value of the switch expr so that it is only evaluated once!
    getExpr().createBCode(gen);

    // Push the hash code for the switch instruction
    if (getExpr().isConstant()) {
      typeString().emitStoreLocal(gen, index_b);

      int hashCode = getExpr().constant().stringValue().hashCode();
      IntegerLiteral.push(gen, hashCode);
    } else {
      typeString().emitDup(gen);
      typeString().emitStoreLocal(gen, index_b);
      hashCodeMethod().emitInvokeMethod(gen,
          lookupType("java.lang", "Object"));
    }

    // Emit switch instruction
    int low = groups.isEmpty() ? 0 : groups.firstKey();
    int high = groups.isEmpty() ? 0 : groups.lastKey();

    int tableSwitchSize = 4 * (3 + (high - low + 1));
    int lookupSwitchSize = 4 * (2 + 2 * groups.size());
    int pad;
    int switchSize;
    int switchPos;
    boolean tableSwitch = tableSwitchSize < lookupSwitchSize;

    gen.addLabel(switch_label);

    // Select the switch type which produces the smallest switch instr.
    if (tableSwitch) {
      // TABLESWITCH
      gen.emit(Bytecode.TABLESWITCH);
      switchSize = tableSwitchSize;
    } else {
      // LOOKUPSWITCH
      gen.emit(Bytecode.LOOKUPSWITCH);
      switchSize = lookupSwitchSize;
    }

    pad = emitPad(gen);
    switchPos = gen.pos();

    // leave room for the address table
    gen.skip(switchSize);

    // Code generation for switch body
    for (CaseGroup group : groups.values()) {
      gen.addLabel(group.lbl);

      // Possible hash miss. Check for equality.
      Iterator<CaseLbl> iter = group.lbls.iterator();
      while (iter.hasNext()) {
        CaseLbl lbl = iter.next();
        int thenLbl;
        if (iter.hasNext())
          thenLbl = hostType().constantPool().newLabel();
        else
          // last conditional branches to end label
          thenLbl = end_label1;

        typeString().emitLoadLocal(gen, index_b);
        StringLiteral.push(gen, lbl.value);
        equalsMethod().emitInvokeMethod(gen,
            lookupType("java.lang", "Object"));
        gen.emitCompare(Bytecode.IFEQ, thenLbl);
        IntegerLiteral.push(gen, lbl.serial);
        typeInt().emitStoreLocal(gen, index_a);
        gen.emitGoto(end_label1);

        if (iter.hasNext())
          gen.addLabel(thenLbl);
      }
    }

    // write jump address table
    int endpos = gen.pos();
    gen.setPos(switchPos);
    if (tableSwitch) {
      int defaultOffset = 1 + pad + switchSize;
      gen.add4(defaultOffset);
      gen.add4(low);
      gen.add4(high);
      for (int i = low; i <= high; i++) {
        if (groups.containsKey(i)) {
          CaseGroup group = groups.get(i);
          int offset = labelOffset(gen, group.lbl, switch_label);
          gen.add4(offset);
        } else {
          gen.add4(defaultOffset);
        }
      }
    } else {
      int defaultOffset = 1 + pad + switchSize;
      gen.add4(defaultOffset);
      gen.add4(groups.size());
      for (CaseGroup group : groups.values()) {
        gen.add4(group.hashCode);
        int offset = labelOffset(gen, group.lbl, switch_label);
        gen.add4(offset);
      }
    }
    gen.setPos(endpos);

    gen.addLabel(end_label1);
  }
  /**
   * 
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:275
   */

  private void genSecondSwitch(
      CodeGeneration gen,
      java.util.List<CaseLbl> labels,
      int index_a,
      CaseLbl defaultLbl) {
    int switch_label = hostType().constantPool().newLabel();
    int default_label = hostType().constantPool().newLabel();

    // push the switch variable
    typeInt().emitLoadLocal(gen, index_a);

    // Emit switch instruction
    gen.addLabel(switch_label);
    gen.emit(Bytecode.TABLESWITCH);
    int high = labels.size();
    int low = 0;
    int pad;
    int switchSize = 4 * (3 + (high - low + 1));
    int switchPos;

    pad = emitPad(gen);
    switchPos = gen.pos();
    gen.skip(switchSize);

    // Code generation for case labels

    for (CaseLbl lbl : labels) {
      gen.addLabel(lbl.lbl);
      lbl.createBCode(gen);
    }

    gen.addLabel(default_label);
    if (defaultLbl != null) {
      defaultLbl.createBCode(gen);
    }

    int endpos = gen.pos();
    gen.setPos(switchPos);
    int defaultOffset = 1 + pad + switchSize;
    gen.add4(defaultOffset);
    gen.add4(low);
    gen.add4(high);
    int offset = labelOffset(gen, default_label, switch_label);
    gen.add4(offset);
    for (CaseLbl lbl : labels) {
      offset = labelOffset(gen, lbl.lbl, switch_label);
      gen.add4(offset);
    }
    gen.setPos(endpos);

    gen.addLabel(end_label());
  }
  /**
   * 
     * Generate invocation of method
     * {@code java.lang.Object.hashCode()}.
     
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:332
   */

  private MethodDecl hashCodeMethod() {
    TypeDecl objectType = lookupType("java.lang", "Object");
    if (objectType == null)
      throw new Error("Could not find java.lang.Object");
    for (MethodDecl method :
        (Collection<MethodDecl>) objectType.memberMethods("hashCode")) {
      if (method.getNumParameter() == 0)
        return method;
    }
    throw new Error("Could not find java.lang.Object.hashCode()");
  }
  /**
   * 
     * Generate invocation of method
     * {@code java.lang.Object.equals(java.lang.Object)}.
     
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:348
   */

  private MethodDecl equalsMethod() {
    TypeDecl objectType = lookupType("java.lang", "Object");
    if (objectType == null)
      throw new Error("Could not find java.lang.Object");
    for (MethodDecl method :
        (Collection<MethodDecl>) objectType.memberMethods("equals")) {
      if (method.getNumParameter() == 1 &&
          method.getParameter(0).getTypeAccess().type() == objectType)
        return method;
    }
    throw new Error("Could not find java.lang.Object.equals()");
  }
  /**
   * 
   * @ast method
   * 
   */

  public SwitchStmt() {
    super();
  }
  /**
   * 
     * Initializes the child array to the correct size.
     * Initializes List and Opt nta children.
     * @apilevel internal
     * @ast method
     
   * @ast method
   * 
   */

  public void init$Children() {
    children = new ASTNode[2];
  }
  /**
   * 
   * @ast method
   * 
   */

  public SwitchStmt(Expr p0, Block p1) {
    setChild(p0, 0);
    setChild(p1, 1);
  }
  /**
   * 
     * @apilevel low-level
     
   * @ast method
   * 
   */

  protected int numChildren() {
    return 2;
  }
  /**
   * 
     * @apilevel internal
     
   * @ast method
   * 
   */

  public boolean mayHaveRewrite() {
    return false;
  }
  /**
   * 
      * @apilevel low-level
      
   * @ast method
   * 
   */

  public void flushCache() {
    super.flushCache();
        isDAafter_Variable_values = null;
    isDUafter_Variable_values = null;
    canCompleteNormally_computed = false;
    defaultCase_computed = false;
    defaultCase_value = null;
    end_label_computed = false;
    typeInt_computed = false;
    typeInt_value = null;
    typeLong_computed = false;
    typeLong_value = null;
  }
  /**
   * 
      * @apilevel internal
      
   * @ast method
   * 
   */

  public void flushCollectionCache() {
    super.flushCollectionCache();
      }
  /**
   * 
     * Replaces the Expr child.
     * @param node The new node to replace the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setExpr(Expr node) {
    setChild(node, 0);
  }
  /**
   * 
     * Retrieves the Expr child.
     * @return The current node used as the Expr child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Expr getExpr() {
    return (Expr) getChild(0);
  }
  /**
   * 
     * Retrieves the Expr child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Expr child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Expr getExprNoTransform() {
    return (Expr) getChildNoTransform(0);
  }
  /**
   * 
     * Replaces the Block child.
     * @param node The new node to replace the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public void setBlock(Block node) {
    setChild(node, 1);
  }
  /**
   * 
     * Retrieves the Block child.
     * @return The current node used as the Block child.
     * @apilevel high-level
     
   * @ast method
   * 
   */

  public Block getBlock() {
    return (Block) getChild(1);
  }
  /**
   * 
     * Retrieves the Block child.
     * <p><em>This method does not invoke AST transformations.</em></p>
     * @return The current node used as the Block child.
     * @apilevel low-level
     
   * @ast method
   * 
   */

  public Block getBlockNoTransform() {
    return (Block) getChildNoTransform(1);
  }
  /**
   * 
   * @ast method
   * @aspect AutoBoxingCodegen
   * @declaredat /home/lessenic/workspace/jastaddj/java5/backend/AutoBoxingCodegen.jrag:125
   */

    public void refined_AutoBoxingCodegen_SwitchStmt_createBCode(CodeGeneration gen) {
    super.createBCode(gen);
    int cond_label = hostType().constantPool().newLabel();
    int switch_label = hostType().constantPool().newLabel();

    gen.emitGoto(cond_label);
    getBlock().createBCode(gen);
    if(canCompleteNormally())
      gen.emitGoto(end_label());
    gen.addLabel(cond_label);
    getExpr().createBCode(gen);
    if(getExpr().type().isReferenceType())
      getExpr().type().emitUnboxingOperation(gen);

    TreeMap map = new TreeMap();
    for(int i = 0; i < getBlock().getNumStmt(); i++) {
      if(getBlock().getStmt(i) instanceof ConstCase) {
        ConstCase ca = (ConstCase)getBlock().getStmt(i);
        map.put(new Integer(ca.getValue().constant().intValue()), ca);
      }
    }

    long low = map.isEmpty() ? 0 : ((Integer)map.firstKey()).intValue();
    long high = map.isEmpty() ? 0 : ((Integer)map.lastKey()).intValue();

    long tableSwitchSize = 8L + (high - low + 1L) * 4L;
    long lookupSwitchSize = 4L + map.size() * 8L;

    gen.addLabel(switch_label);
    if(tableSwitchSize < lookupSwitchSize) {
      gen.emit(Bytecode.TABLESWITCH);
      int pad = emitPad(gen);
      int defaultOffset = defaultOffset(gen, switch_label);
      if(defaultOffset == 0) {
        defaultOffset = 1 + pad + 4 + 4 + 4 + 4 * (int)(high - low + 1);
      }
      gen.add4(defaultOffset);
      gen.add4((int)low);
      gen.add4((int)high);
      for(long i = low; i <= high; i++) {
        ConstCase ca = (ConstCase)map.get(new Integer((int)i));
        if(ca != null) {
          int offset = gen.addressOf(ca.label())
            - gen.addressOf(switch_label);
          gen.add4(offset);
        }
        else {
          gen.add4(defaultOffset);
        }
      }
    }
    else {
      gen.emit(Bytecode.LOOKUPSWITCH);
      int pad = emitPad(gen);
      int defaultOffset = defaultOffset(gen, switch_label);
      if(defaultOffset == 0) {
        defaultOffset = 1 + pad + 4 + 4 + 8 * numCase();
      }
      gen.add4(defaultOffset);
      gen.add4(map.size());
      for(Iterator iter = map.values().iterator(); iter.hasNext(); ) {
        ConstCase ca = (ConstCase)iter.next();
        gen.add4(ca.getValue().constant().intValue());
        int offset = gen.addressOf(ca.label())
          - gen.addressOf(switch_label);
        gen.add4(offset);
      }
    }
    gen.addLabel(end_label());
  }
  /**
   * 
   * @ast method
   * @aspect Enums
   * @declaredat /home/lessenic/workspace/jastaddj/java5/frontend/Enums.jrag:491
   */

    public void refined_Enums_SwitchStmt_typeCheck() {
     TypeDecl type = getExpr().type();
    if((!type.isIntegralType() || type.isLong()) && !type.isEnumDecl())
      error("Switch expression must be of char, byte, short, int, or enum type");
  }
  /**
   * 
     * <p>Overrides the type checking of the switch statement's expression.
     *
     * <p>In JSR 334 a switch statement may use an expression of type String.
     
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/StringsInSwitch.jrag:25
   */

    public void typeCheck() {
    TypeDecl type = getExpr().type();
    if ((!type.isIntegralType() || type.isLong()) && !type.isEnumDecl()
        && !type.isString())
      error("Switch expression must be of type " +
          "char, byte, short, int, enum, or string");
  }
  /**
   * 
     * Two switch statements are generated.
     * The first switch will switch on the hash code of the switch expression.
     * The first switch statement computes a value for a variable that selects
     * a case in the second switch statement.
     *
     
   * @ast method
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:110
   */

   
    public void createBCode(CodeGeneration gen) {
    if (getExpr().type().isString()) {
      // add line number for start of statement
      super.createBCode(gen);

      // Enumerate case labels with same hash value
      TreeMap< Integer, CaseGroup > groups =
        new TreeMap< Integer, CaseGroup >();
      java.util.List<CaseLbl> labels = new LinkedList<CaseLbl>();

      CaseLbl defaultLbl = null;
      CaseLbl caseLbl = null;
      int serial = 1;
      for (Stmt stmt : getBlock().getStmts()) {
        if (stmt instanceof ConstCase) {
          ConstCase cc = (ConstCase) stmt;
          caseLbl = new CaseLbl(cc, gen);
          caseLbl.serial = serial++;
          labels.add(caseLbl);
          int key = caseLbl.value.hashCode();
          if (groups.containsKey(key)) {
            groups.get(key).addCase(caseLbl);
          } else {
            CaseGroup group = new CaseGroup(this, key);
            group.addCase(caseLbl);
            groups.put(key, group);
          }
        } else if (stmt instanceof DefaultCase) {
          defaultLbl =
            new CaseLbl(hostType().constantPool().newLabel());
          caseLbl = defaultLbl;
        } else if (caseLbl != null) {
          caseLbl.addStmt(stmt);
        }
      }

      int index_a = localNumA();
      genFirstSwitch(gen, groups, index_a);
      genSecondSwitch(gen, labels, index_a, defaultLbl);

    } else {
      refined_AutoBoxingCodegen_SwitchStmt_createBCode(gen);
    }
  }
    /**
       * @return <code>true</code> if this statement is a potential
       * branch target of the given branch statement.
       
     * @attribute syn
     * @aspect BranchTarget
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:196
     */
  public boolean potentialTargetOf(Stmt branch) {
    ASTNode$State state = state();
    try {  return branch.canBranchTo(this);  }
    finally {
    }
  }
  protected java.util.Map isDAafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DA
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:531
   */

  public boolean isDAafter(Variable v) {
    Object _parameters = v;
    if(isDAafter_Variable_values == null) isDAafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDAafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDAafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDAafter_Variable_value = isDAafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDAafter_Variable_values.put(_parameters, Boolean.valueOf(isDAafter_Variable_value)); }
        return isDAafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDAafter_compute(Variable v) {
      if(!(!noDefaultLabel() || getExpr().isDAafter(v))) {
        return false;
      }
      if(!(!switchLabelEndsBlock() || getExpr().isDAafter(v))) {
        return false;
      }
      if(!assignedAfterLastStmt(v)) {
        return false;
      }
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDAafterReachedFinallyBlocks(v))
          return false;
      }
      return true;
    }
    /**
     * @attribute syn
     * @aspect DA
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:549
     */
  public boolean assignedAfterLastStmt(Variable v) {
    ASTNode$State state = state();
    try {  return getBlock().isDAafter(v);  }
    finally {
    }
  }
  protected java.util.Map isDUafter_Variable_values;
  /**
   * @attribute syn
   * @aspect DU
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1015
   */

  public boolean isDUafter(Variable v) {
    Object _parameters = v;
    if(isDUafter_Variable_values == null) isDUafter_Variable_values = new org.jastadd.util.RobustMap(new java.util.HashMap());
    

    
if(isDUafter_Variable_values.containsKey(_parameters)) {
  return ((Boolean)isDUafter_Variable_values.get(_parameters)).booleanValue(); 
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    boolean isDUafter_Variable_value = isDUafter_compute(v);
      if(isFinal && num == state().boundariesCrossed){ isDUafter_Variable_values.put(_parameters, Boolean.valueOf(isDUafter_Variable_value)); }
        return isDUafter_Variable_value;
  }
  /**
   * @apilevel internal
   */
  private boolean isDUafter_compute(Variable v) {
      if(!(!noDefaultLabel() || getExpr().isDUafter(v)))
        return false;
      if(!(!switchLabelEndsBlock() || getExpr().isDUafter(v)))
        return false;
      if(!unassignedAfterLastStmt(v))
        return false;
      for(Iterator iter = targetBreaks().iterator(); iter.hasNext(); ) {
        BreakStmt stmt = (BreakStmt)iter.next();
        if(!stmt.isDUafterReachedFinallyBlocks(v))
          return false;
      }
      return true;
    }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1030
     */
  public boolean unassignedAfterLastStmt(Variable v) {
    ASTNode$State state = state();
    try {  return getBlock().isDUafter(v);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect DU
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1033
     */
  public boolean switchLabelEndsBlock() {
    ASTNode$State state = state();
    try {  return getBlock().getNumStmt() > 0 && getBlock().getStmt(getBlock().getNumStmt()-1) instanceof ConstCase;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect UnreachableStatements
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:60
     */
  public boolean lastStmtCanCompleteNormally() {
    ASTNode$State state = state();
    try {  return getBlock().canCompleteNormally();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect UnreachableStatements
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:62
     */
  public boolean noStmts() {
    ASTNode$State state = state();
    try {
        for(int i = 0; i < getBlock().getNumStmt(); i++)
          if(!(getBlock().getStmt(i) instanceof Case))
            return false;
        return true;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect UnreachableStatements
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:69
     */
  public boolean noStmtsAfterLastLabel() {
    ASTNode$State state = state();
    try {  return getBlock().getNumStmt() > 0 && getBlock().getStmt(getBlock().getNumStmt()-1) instanceof Case;  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect UnreachableStatements
     * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:72
     */
  public boolean noDefaultLabel() {
    ASTNode$State state = state();
    try {
        for(int i = 0; i < getBlock().getNumStmt(); i++)
          if(getBlock().getStmt(i) instanceof DefaultCase)
            return false;
        return true;
      }
    finally {
    }
  }
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_computed = false;
  /**
   * @apilevel internal
   */
  protected boolean canCompleteNormally_value;
  /**
   * @attribute syn
   * @aspect UnreachableStatements
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:79
   */

  public boolean canCompleteNormally() {
    

    
if(canCompleteNormally_computed) {
  return canCompleteNormally_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    canCompleteNormally_value = canCompleteNormally_compute();
      if(isFinal && num == state().boundariesCrossed){ canCompleteNormally_computed = true; }
        return canCompleteNormally_value;
  }
  /**
   * @apilevel internal
   */
  private boolean canCompleteNormally_compute() {  return lastStmtCanCompleteNormally() || noStmts() || noStmtsAfterLastLabel() || noDefaultLabel() || reachableBreak();  }
  /**
   * @apilevel internal
   */
  protected boolean defaultCase_computed = false;
  /**
   * @apilevel internal
   */
  protected DefaultCase defaultCase_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1233
   */

  public DefaultCase defaultCase() {
    

    
if(defaultCase_computed) {
  return defaultCase_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    defaultCase_value = defaultCase_compute();
      if(isFinal && num == state().boundariesCrossed){ defaultCase_computed = true; }
        return defaultCase_value;
  }
  /**
   * @apilevel internal
   */
  private DefaultCase defaultCase_compute() {
      for(int i= 0; i < getBlock().getNumStmt(); i++) {
        if(getBlock().getStmt(i) instanceof DefaultCase)
          return (DefaultCase)getBlock().getStmt(i);
      }
      return null;
    }
  /**
   * @apilevel internal
   */
  protected boolean end_label_computed = false;
  /**
   * @apilevel internal
   */
  protected int end_label_value;
  /**
   * @attribute syn
   * @aspect CreateBCode
   * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1241
   */

  public int end_label() {
    

    
if(end_label_computed) {
  return end_label_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    end_label_value = end_label_compute();
      if(isFinal && num == state().boundariesCrossed){ end_label_computed = true; }
        return end_label_value;
  }
  /**
   * @apilevel internal
   */
  private int end_label_compute() {  return hostType().constantPool().newLabel();  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1329
     */
  public int numCase() {
    ASTNode$State state = state();
    try {
        int result = 0;
        for(int i = 0; i < getBlock().getNumStmt(); i++)
          if(getBlock().getStmt(i) instanceof Case)
            result++;
        return result;
      }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect CreateBCode
     * @declaredat /home/lessenic/workspace/jastaddj/java4/backend/CreateBCode.jrag:1446
     */
  public int break_label() {
    ASTNode$State state = state();
    try {  return end_label();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect PreciseRethrow
     * @declaredat /home/lessenic/workspace/jastaddj/java7/frontend/PreciseRethrow.jrag:55
     */
  public boolean modifiedInScope(Variable var) {
    ASTNode$State state = state();
    try {  return getBlock().modifiedInScope(var);  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect StringsInSwitch
     * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:21
     */
  public boolean isSwitchWithString() {
    ASTNode$State state = state();
    try {  return getExpr().type().isString();  }
    finally {
    }
  }
    /**
     * @attribute syn
     * @aspect StringsInSwitch
     * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:38
     */
  public int localNumA() {
    ASTNode$State state = state();
    try {  return localNum();  }
    finally {
    }
  }
    /**
       * Local index for the second switch variable.
       
     * @attribute syn
     * @aspect StringsInSwitch
     * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:44
     */
  public int localNumB() {
    ASTNode$State state = state();
    try {  return localNum() + typeInt().variableSize();  }
    finally {
    }
  }
    /**
       * Utility method to compute offsets between labels.
       
     * @attribute syn
     * @aspect StringsInSwitch
     * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:100
     */
  public int labelOffset(CodeGeneration gen, int lbl1, int lbl2) {
    ASTNode$State state = state();
    try {  return gen.addressOf(lbl1) - gen.addressOf(lbl2);  }
    finally {
    }
  }
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:61
   */

  public TypeDecl typeInt() {
    

    
if(typeInt_computed) {
  return typeInt_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    typeInt_value = getParent().Define_TypeDecl_typeInt(this, null);
      if(isFinal && num == state().boundariesCrossed){ typeInt_computed = true; }
        return typeInt_value;
  }
  /**
   * @apilevel internal
   */
  protected boolean typeInt_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl typeInt_value;
  /**
   * @attribute inh
   * @aspect SpecialClasses
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/LookupType.jrag:63
   */

  public TypeDecl typeLong() {
    

    
if(typeLong_computed) {
  return typeLong_value;
}

    ASTNode$State state = state();
    int num = state.boundariesCrossed;
    boolean isFinal = this.is$Final();
    typeLong_value = getParent().Define_TypeDecl_typeLong(this, null);
      if(isFinal && num == state().boundariesCrossed){ typeLong_computed = true; }
        return typeLong_value;
  }
  /**
   * @apilevel internal
   */
  protected boolean typeLong_computed = false;
  /**
   * @apilevel internal
   */
  protected TypeDecl typeLong_value;
  /**
   * @attribute inh
   * @aspect StringsInSwitch
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:25
   */

  public TypeDecl typeString() {
    ASTNode$State state = state();
    TypeDecl typeString_value = getParent().Define_TypeDecl_typeString(this, null);
        return typeString_value;
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/BranchTarget.jrag:225
   * @apilevel internal
   */
  public Stmt Define_Stmt_branchTarget(ASTNode caller, ASTNode child, Stmt branch) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return branch.canBranchTo(this) ? this : branchTarget(branch);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:568
   * @apilevel internal
   */
  public boolean Define_boolean_isDAbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return getExpr().isDAafter(v);
    }
    else if(caller == getExprNoTransform()){
    if(((ASTNode)v).isDescendantTo(this))
      return false;
    boolean result = isDAbefore(v);
    return result;
  }
    else {      return getParent().Define_boolean_isDAbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/DefiniteAssignment.jrag:1038
   * @apilevel internal
   */
  public boolean Define_boolean_isDUbefore(ASTNode caller, ASTNode child, Variable v) {
    if(caller == getBlockNoTransform()) {
      return getExpr().isDUafter(v);
    }
    else if(caller == getExprNoTransform()) {
      return isDUbefore(v);
    }
    else {      return getParent().Define_boolean_isDUbefore(this, caller, v);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:399
   * @apilevel internal
   */
  public boolean Define_boolean_insideSwitch(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return true;
    }
    else {      return getParent().Define_boolean_insideSwitch(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/NameCheck.jrag:441
   * @apilevel internal
   */
  public Case Define_Case_bind(ASTNode caller, ASTNode child, Case c) {
    if(caller == getBlockNoTransform()){
    Block b = getBlock();
    for(int i = 0; i < b.getNumStmt(); i++)
      if(b.getStmt(i) instanceof Case && ((Case)b.getStmt(i)).constValue(c))
        return (Case)b.getStmt(i);
    return null;
  }
    else {      return getParent().Define_Case_bind(this, caller, c);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/TypeCheck.jrag:359
   * @apilevel internal
   */
  public TypeDecl Define_TypeDecl_switchType(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return getExpr().type();
    }
    else {      return getParent().Define_TypeDecl_switchType(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:82
   * @apilevel internal
   */
  public boolean Define_boolean_reachable(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java4/frontend/UnreachableStatements.jrag:158
   * @apilevel internal
   */
  public boolean Define_boolean_reportUnreachable(ASTNode caller, ASTNode child) {
    if(caller == getBlockNoTransform()) {
      return reachable();
    }
    else {      return getParent().Define_boolean_reportUnreachable(this, caller);
    }
  }
  /**
   * @declaredat /home/lessenic/workspace/jastaddj/java7/backend/StringsInSwitch.jrag:30
   * @apilevel internal
   */
  public int Define_int_localNum(ASTNode caller, ASTNode child) {
     {
      int childIndex = this.getIndexOfChild(caller);
      return //isSwitchWithString()
    localNum() + typeInt().variableSize() + typeString().variableSize();
    }
  }
  /**
   * @apilevel internal
   */
  public ASTNode rewriteTo() {    return super.rewriteTo();
  }}
